#include <iostream>
#include<cmath>
#include <complex>
using namespace std;

/* 10.3 Lie Series Method */

double magnitude(double a, double b) {
	return sqrt(a*a+b*b);
}

int main(void) {


	complex<double> r(40.0,0.0);
	complex<double> s(16.0,0.0);
	complex<double> b(4.0,0.0);
	complex<double> count(0.0,0.0);
	complex<double> eps(0.0,0.01);
	complex<double> half(0.5,0.0);
	complex<double> usl(0.8,0.0);
	complex<double> us2(0.8,0.0);
	complex<double> us3(0.8,0.0);
	complex<double> ul, u2, u3;

	while(magnitude(count.real(), count.imag()) < 2.0) {
		ul = usl;
		u2 = us2;
		u3 = us3;
		complex<double> V1 = s*(u2-ul);
		complex<double> V2 = -u2-ul*u3+r*ul;
		complex<double> V3 = ul*u2-b*u3;
		complex<double> Wl = s*s*(ul-u2) + s*(-u2-ul*u3+r*ul);
		complex<double> W2 = u2+ul*u3-r*ul - s*(u2-ul)*u3
		                     - (ul*u2-b*u3)*ul + r*s*(u2-ul);
		complex<double> W3 = s*u2*(u2-ul) + (-u2-ul*u3+r*ul)*ul
		                     -b*(ul*u2-b*u3);
		usl = ul + eps*V1 + half*eps*eps*Wl;
		us2 = u2 + eps*V2 + half*eps*eps*W2;
		us3 = u3 + eps*V3 + half*eps*eps*W3;
		count += eps;
	}
	cout << usl << endl;
	cout << us2 << endl;
	cout << us3 << endl;
	return 0;
}
