#include <iostream>
#include <cmath>
#include<fstream>
using namespace std;

/* 10.7 Verlet Method */


int main(void) {
	ofstream resultFileTheta("verletResultTheta.dat");
	ofstream resultFileAccel("verletResultAccel.dat");
	const double pi = 3.141592654;
	double theta =1.4 ; // initial angle (in radians)
	double omega =0.0 ; // initial velocity
	double g_over_L = 1.0; // the constant g/L
	double time =0.0 ; // initial time
	double time_old; // time of previous reversal
	double tau = 0.005; // time step size
	// take one backward step to start Verlet
	double accel = -g_over_L*sin(theta); // gravitational acceleration
	double theta_old = theta - omega*tau + 0.5*tau*tau*accel;
	int nStep = 2000; // number of steps
	for(int i=1; i<=nStep; i++) {
		time += tau;
		accel = - g_over_L*sin(theta);
		double theta_new = 2.0*theta - theta_old + tau*tau*accel;
		cout << "time = " << time << " "
		     << "theta = " << theta_new << " "
		     << "accel = " << accel;
		cout << endl;
		resultFileTheta << time << " " << theta << endl;
		resultFileAccel << time << " " << accel << endl;
		theta_old = theta;
		theta = theta_new;
	}
	resultFileTheta.close();
	resultFileAccel.close();
	return 0;
}
