
#include <fstream>
using namespace std;

const int N = 2;

void fsystem(double h,double t,double u[N],double hf[N])
{
	double mu = 5.0;
	hf[0] = h*u[1];
	hf[1] = h*(-u[0] + mu*(1.0 - u[0]*u[0])*u[1]);
}

void map(double u[N], int steps, double h, double t)
{
	double uk[N];
	double tk;
	double a[6] = { 0.0, 1.0/4.0, 3.0/8.0, 12.0/13.0, 1.0, 1.0/2.0 };
	double c[6] = { 16.0/135.0, 0.0, 6656.0/12825.0, 28561.0/56430.0,
					-9.0/50.0, 2.0/55.0 };
	double b[6][5];
	b[0][0] = b[0][1] = b[0][2] = b[0][3] = b[0][4] = 0.0;
	b[1][0] = 1.0/4.0; b[1][1] = 0.0; b[1][2] = 0.0; b[1][3] = 0.0;
	b[1][4] = 0.0;
	b[2][0] = 3.0/32.0; b[2][1] = 9.0/32.0;
	b[2][2] = 0.0; b[2][3] = 0.0; b[2][4] = 0.0;
	b[3][0] = 1932.0/2197.0; b[3][1] = -7200.0/2197.0;
	b[3][2] = 7296.0/2197.0; b[3][3] = b[3][4] = 0.0;
	b[4][0] = 439.0/216.0; b[4][1] = -8.0;
	b[4][2] = 3680.0/513.0; b[4][3] = -845.0/4104.0;
	b[4][4] = 0.0;
	b[5][0] = -8.0/27.0; b[5][1] = 2.0;
	b[5][2] = -3544.0/2565.0; b[5][3] = 1859.0/4104.0;
	b[5][4] = -11.0/4.0;
	
	double f[6][N];
	int i, j, l, k;
	
	for(i=0; i<steps; i++)
	{
	fsystem(h,t,u,f[0]);
	for(k=1;k<=5;k++)
	{
	tk = t + a[k]*h;
	for(l=0;l<N;l++)
	{
	uk[l]  = u[l];
	for(j=0;j<=k-1;j++)
	uk[l] += b[k][j]*f[j][l];
	}
	fsystem(h,tk,uk,f[k]);
	}
	for(l=0;l<N;l++)
	for(k=0; k<6; k++)
	u[l] += c[k]*f[k][l];
	}
}

int main(void)
{
	ofstream data;
	data.open("phase_data.dat");
	int steps = 1;
	double h = 0.005;
	double t = 0.0;
	double u[N] = { 0.1, 0.2 };  // initial conditions
	int i;
	// wait for transients to decay
	for(i=0;i<1000;i++)
	{ t += h; map(u,steps,h,t); }
	
	t = 0.0;
	for(i=0;i<40000;i++)
	{
	t += h;
	map(u,steps,h,t);
	data << u[0] << " " << u[1] << "\n";
	}
	data.close();
	return 0;
}
